# coding: utf-8

"""
    Firefly III API Client

    This is the Python client for Firefly III API

    The version of the OpenAPI document: 6.1.24
    Contact: james@firefly-iii.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from datetime import date
from pydantic import Field, StrictInt, StrictStr
from typing import Optional
from typing_extensions import Annotated
from firefly_iii_client.models.recurrence_array import RecurrenceArray
from firefly_iii_client.models.recurrence_single import RecurrenceSingle
from firefly_iii_client.models.recurrence_store import RecurrenceStore
from firefly_iii_client.models.recurrence_update import RecurrenceUpdate
from firefly_iii_client.models.transaction_array import TransactionArray
from firefly_iii_client.models.transaction_type_filter import TransactionTypeFilter

from firefly_iii_client.api_client import ApiClient, RequestSerialized
from firefly_iii_client.api_response import ApiResponse
from firefly_iii_client.rest import RESTResponseType


class RecurrencesApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def delete_recurrence(
        self,
        id: Annotated[StrictStr, Field(description="The ID of the recurring transaction.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> None:
        """Delete a recurring transaction.

        Delete a recurring transaction. Transactions created by the recurring transaction will not be deleted.

        :param id: The ID of the recurring transaction. (required)
        :type id: str
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._delete_recurrence_serialize(
            id=id,
            x_trace_id=x_trace_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '204': None,
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def delete_recurrence_with_http_info(
        self,
        id: Annotated[StrictStr, Field(description="The ID of the recurring transaction.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[None]:
        """Delete a recurring transaction.

        Delete a recurring transaction. Transactions created by the recurring transaction will not be deleted.

        :param id: The ID of the recurring transaction. (required)
        :type id: str
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._delete_recurrence_serialize(
            id=id,
            x_trace_id=x_trace_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '204': None,
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def delete_recurrence_without_preload_content(
        self,
        id: Annotated[StrictStr, Field(description="The ID of the recurring transaction.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Delete a recurring transaction.

        Delete a recurring transaction. Transactions created by the recurring transaction will not be deleted.

        :param id: The ID of the recurring transaction. (required)
        :type id: str
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._delete_recurrence_serialize(
            id=id,
            x_trace_id=x_trace_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '204': None,
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _delete_recurrence_serialize(
        self,
        id,
        x_trace_id,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if id is not None:
            _path_params['id'] = id
        # process the query parameters
        # process the header parameters
        if x_trace_id is not None:
            _header_params['X-Trace-Id'] = x_trace_id
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/json'
            ]
        )


        # authentication setting
        _auth_settings: List[str] = [
            'firefly_iii_auth', 
            'local_bearer_auth'
        ]

        return self.api_client.param_serialize(
            method='DELETE',
            resource_path='/v1/recurrences/{id}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def get_recurrence(
        self,
        id: Annotated[StrictStr, Field(description="The ID of the recurring transaction.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RecurrenceSingle:
        """Get a single recurring transaction.

        Get a single recurring transaction.

        :param id: The ID of the recurring transaction. (required)
        :type id: str
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_recurrence_serialize(
            id=id,
            x_trace_id=x_trace_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RecurrenceSingle",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def get_recurrence_with_http_info(
        self,
        id: Annotated[StrictStr, Field(description="The ID of the recurring transaction.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[RecurrenceSingle]:
        """Get a single recurring transaction.

        Get a single recurring transaction.

        :param id: The ID of the recurring transaction. (required)
        :type id: str
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_recurrence_serialize(
            id=id,
            x_trace_id=x_trace_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RecurrenceSingle",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def get_recurrence_without_preload_content(
        self,
        id: Annotated[StrictStr, Field(description="The ID of the recurring transaction.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Get a single recurring transaction.

        Get a single recurring transaction.

        :param id: The ID of the recurring transaction. (required)
        :type id: str
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_recurrence_serialize(
            id=id,
            x_trace_id=x_trace_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RecurrenceSingle",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _get_recurrence_serialize(
        self,
        id,
        x_trace_id,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if id is not None:
            _path_params['id'] = id
        # process the query parameters
        # process the header parameters
        if x_trace_id is not None:
            _header_params['X-Trace-Id'] = x_trace_id
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/vnd.api+json', 
                'application/json'
            ]
        )


        # authentication setting
        _auth_settings: List[str] = [
            'firefly_iii_auth', 
            'local_bearer_auth'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/v1/recurrences/{id}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def list_recurrence(
        self,
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        limit: Annotated[Optional[StrictInt], Field(description="Number of items per page. The default pagination is per 50 items.")] = None,
        page: Annotated[Optional[StrictInt], Field(description="Page number. The default pagination is per 50 items.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RecurrenceArray:
        """List all recurring transactions.

        List all recurring transactions.

        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param limit: Number of items per page. The default pagination is per 50 items.
        :type limit: int
        :param page: Page number. The default pagination is per 50 items.
        :type page: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._list_recurrence_serialize(
            x_trace_id=x_trace_id,
            limit=limit,
            page=page,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RecurrenceArray",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def list_recurrence_with_http_info(
        self,
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        limit: Annotated[Optional[StrictInt], Field(description="Number of items per page. The default pagination is per 50 items.")] = None,
        page: Annotated[Optional[StrictInt], Field(description="Page number. The default pagination is per 50 items.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[RecurrenceArray]:
        """List all recurring transactions.

        List all recurring transactions.

        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param limit: Number of items per page. The default pagination is per 50 items.
        :type limit: int
        :param page: Page number. The default pagination is per 50 items.
        :type page: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._list_recurrence_serialize(
            x_trace_id=x_trace_id,
            limit=limit,
            page=page,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RecurrenceArray",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def list_recurrence_without_preload_content(
        self,
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        limit: Annotated[Optional[StrictInt], Field(description="Number of items per page. The default pagination is per 50 items.")] = None,
        page: Annotated[Optional[StrictInt], Field(description="Page number. The default pagination is per 50 items.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """List all recurring transactions.

        List all recurring transactions.

        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param limit: Number of items per page. The default pagination is per 50 items.
        :type limit: int
        :param page: Page number. The default pagination is per 50 items.
        :type page: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._list_recurrence_serialize(
            x_trace_id=x_trace_id,
            limit=limit,
            page=page,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RecurrenceArray",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _list_recurrence_serialize(
        self,
        x_trace_id,
        limit,
        page,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if limit is not None:
            
            _query_params.append(('limit', limit))
            
        if page is not None:
            
            _query_params.append(('page', page))
            
        # process the header parameters
        if x_trace_id is not None:
            _header_params['X-Trace-Id'] = x_trace_id
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/vnd.api+json', 
                'application/json'
            ]
        )


        # authentication setting
        _auth_settings: List[str] = [
            'firefly_iii_auth', 
            'local_bearer_auth'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/v1/recurrences',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def list_transaction_by_recurrence(
        self,
        id: Annotated[StrictStr, Field(description="The ID of the recurring transaction.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        limit: Annotated[Optional[StrictInt], Field(description="Number of items per page. The default pagination is per 50 items.")] = None,
        page: Annotated[Optional[StrictInt], Field(description="Page number. The default pagination is per 50 items.")] = None,
        start: Annotated[Optional[date], Field(description="A date formatted YYYY-MM-DD. Both the start and end date must be present. ")] = None,
        end: Annotated[Optional[date], Field(description="A date formatted YYYY-MM-DD. Both the start and end date must be present. ")] = None,
        type: Annotated[Optional[TransactionTypeFilter], Field(description="Optional filter on the transaction type(s) returned")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> TransactionArray:
        """List all transactions created by a recurring transaction.

        List all transactions created by a recurring transaction, optionally limited to the date ranges specified.

        :param id: The ID of the recurring transaction. (required)
        :type id: str
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param limit: Number of items per page. The default pagination is per 50 items.
        :type limit: int
        :param page: Page number. The default pagination is per 50 items.
        :type page: int
        :param start: A date formatted YYYY-MM-DD. Both the start and end date must be present. 
        :type start: date
        :param end: A date formatted YYYY-MM-DD. Both the start and end date must be present. 
        :type end: date
        :param type: Optional filter on the transaction type(s) returned
        :type type: TransactionTypeFilter
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._list_transaction_by_recurrence_serialize(
            id=id,
            x_trace_id=x_trace_id,
            limit=limit,
            page=page,
            start=start,
            end=end,
            type=type,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "TransactionArray",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def list_transaction_by_recurrence_with_http_info(
        self,
        id: Annotated[StrictStr, Field(description="The ID of the recurring transaction.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        limit: Annotated[Optional[StrictInt], Field(description="Number of items per page. The default pagination is per 50 items.")] = None,
        page: Annotated[Optional[StrictInt], Field(description="Page number. The default pagination is per 50 items.")] = None,
        start: Annotated[Optional[date], Field(description="A date formatted YYYY-MM-DD. Both the start and end date must be present. ")] = None,
        end: Annotated[Optional[date], Field(description="A date formatted YYYY-MM-DD. Both the start and end date must be present. ")] = None,
        type: Annotated[Optional[TransactionTypeFilter], Field(description="Optional filter on the transaction type(s) returned")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[TransactionArray]:
        """List all transactions created by a recurring transaction.

        List all transactions created by a recurring transaction, optionally limited to the date ranges specified.

        :param id: The ID of the recurring transaction. (required)
        :type id: str
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param limit: Number of items per page. The default pagination is per 50 items.
        :type limit: int
        :param page: Page number. The default pagination is per 50 items.
        :type page: int
        :param start: A date formatted YYYY-MM-DD. Both the start and end date must be present. 
        :type start: date
        :param end: A date formatted YYYY-MM-DD. Both the start and end date must be present. 
        :type end: date
        :param type: Optional filter on the transaction type(s) returned
        :type type: TransactionTypeFilter
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._list_transaction_by_recurrence_serialize(
            id=id,
            x_trace_id=x_trace_id,
            limit=limit,
            page=page,
            start=start,
            end=end,
            type=type,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "TransactionArray",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def list_transaction_by_recurrence_without_preload_content(
        self,
        id: Annotated[StrictStr, Field(description="The ID of the recurring transaction.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        limit: Annotated[Optional[StrictInt], Field(description="Number of items per page. The default pagination is per 50 items.")] = None,
        page: Annotated[Optional[StrictInt], Field(description="Page number. The default pagination is per 50 items.")] = None,
        start: Annotated[Optional[date], Field(description="A date formatted YYYY-MM-DD. Both the start and end date must be present. ")] = None,
        end: Annotated[Optional[date], Field(description="A date formatted YYYY-MM-DD. Both the start and end date must be present. ")] = None,
        type: Annotated[Optional[TransactionTypeFilter], Field(description="Optional filter on the transaction type(s) returned")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """List all transactions created by a recurring transaction.

        List all transactions created by a recurring transaction, optionally limited to the date ranges specified.

        :param id: The ID of the recurring transaction. (required)
        :type id: str
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param limit: Number of items per page. The default pagination is per 50 items.
        :type limit: int
        :param page: Page number. The default pagination is per 50 items.
        :type page: int
        :param start: A date formatted YYYY-MM-DD. Both the start and end date must be present. 
        :type start: date
        :param end: A date formatted YYYY-MM-DD. Both the start and end date must be present. 
        :type end: date
        :param type: Optional filter on the transaction type(s) returned
        :type type: TransactionTypeFilter
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._list_transaction_by_recurrence_serialize(
            id=id,
            x_trace_id=x_trace_id,
            limit=limit,
            page=page,
            start=start,
            end=end,
            type=type,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "TransactionArray",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _list_transaction_by_recurrence_serialize(
        self,
        id,
        x_trace_id,
        limit,
        page,
        start,
        end,
        type,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if id is not None:
            _path_params['id'] = id
        # process the query parameters
        if limit is not None:
            
            _query_params.append(('limit', limit))
            
        if page is not None:
            
            _query_params.append(('page', page))
            
        if start is not None:
            if isinstance(start, date):
                _query_params.append(
                    (
                        'start',
                        start.strftime(
                            self.api_client.configuration.date_format
                        )
                    )
                )
            else:
                _query_params.append(('start', start))
            
        if end is not None:
            if isinstance(end, date):
                _query_params.append(
                    (
                        'end',
                        end.strftime(
                            self.api_client.configuration.date_format
                        )
                    )
                )
            else:
                _query_params.append(('end', end))
            
        if type is not None:
            
            _query_params.append(('type', type.value))
            
        # process the header parameters
        if x_trace_id is not None:
            _header_params['X-Trace-Id'] = x_trace_id
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/vnd.api+json', 
                'application/json'
            ]
        )


        # authentication setting
        _auth_settings: List[str] = [
            'firefly_iii_auth', 
            'local_bearer_auth'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/v1/recurrences/{id}/transactions',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def store_recurrence(
        self,
        recurrence_store: Annotated[RecurrenceStore, Field(description="JSON array or key=value pairs with the necessary recurring transaction information. See the model for the exact specifications.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RecurrenceSingle:
        """Store a new recurring transaction

        Creates a new recurring transaction. The data required can be submitted as a JSON body or as a list of parameters.

        :param recurrence_store: JSON array or key=value pairs with the necessary recurring transaction information. See the model for the exact specifications. (required)
        :type recurrence_store: RecurrenceStore
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._store_recurrence_serialize(
            recurrence_store=recurrence_store,
            x_trace_id=x_trace_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RecurrenceSingle",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '422': "ValidationErrorResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def store_recurrence_with_http_info(
        self,
        recurrence_store: Annotated[RecurrenceStore, Field(description="JSON array or key=value pairs with the necessary recurring transaction information. See the model for the exact specifications.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[RecurrenceSingle]:
        """Store a new recurring transaction

        Creates a new recurring transaction. The data required can be submitted as a JSON body or as a list of parameters.

        :param recurrence_store: JSON array or key=value pairs with the necessary recurring transaction information. See the model for the exact specifications. (required)
        :type recurrence_store: RecurrenceStore
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._store_recurrence_serialize(
            recurrence_store=recurrence_store,
            x_trace_id=x_trace_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RecurrenceSingle",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '422': "ValidationErrorResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def store_recurrence_without_preload_content(
        self,
        recurrence_store: Annotated[RecurrenceStore, Field(description="JSON array or key=value pairs with the necessary recurring transaction information. See the model for the exact specifications.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Store a new recurring transaction

        Creates a new recurring transaction. The data required can be submitted as a JSON body or as a list of parameters.

        :param recurrence_store: JSON array or key=value pairs with the necessary recurring transaction information. See the model for the exact specifications. (required)
        :type recurrence_store: RecurrenceStore
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._store_recurrence_serialize(
            recurrence_store=recurrence_store,
            x_trace_id=x_trace_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RecurrenceSingle",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '422': "ValidationErrorResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _store_recurrence_serialize(
        self,
        recurrence_store,
        x_trace_id,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        if x_trace_id is not None:
            _header_params['X-Trace-Id'] = x_trace_id
        # process the form parameters
        # process the body parameter
        if recurrence_store is not None:
            _body_params = recurrence_store


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/vnd.api+json', 
                'application/json'
            ]
        )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json', 
                        'application/x-www-form-urlencoded'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'firefly_iii_auth', 
            'local_bearer_auth'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/v1/recurrences',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def update_recurrence(
        self,
        id: Annotated[StrictStr, Field(description="The ID of the recurring transaction.")],
        recurrence_update: Annotated[RecurrenceUpdate, Field(description="JSON array with updated recurring transaction information. See the model for the exact specifications.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RecurrenceSingle:
        """Update existing recurring transaction.

        Update existing recurring transaction.

        :param id: The ID of the recurring transaction. (required)
        :type id: str
        :param recurrence_update: JSON array with updated recurring transaction information. See the model for the exact specifications. (required)
        :type recurrence_update: RecurrenceUpdate
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._update_recurrence_serialize(
            id=id,
            recurrence_update=recurrence_update,
            x_trace_id=x_trace_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RecurrenceSingle",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '422': "ValidationErrorResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def update_recurrence_with_http_info(
        self,
        id: Annotated[StrictStr, Field(description="The ID of the recurring transaction.")],
        recurrence_update: Annotated[RecurrenceUpdate, Field(description="JSON array with updated recurring transaction information. See the model for the exact specifications.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[RecurrenceSingle]:
        """Update existing recurring transaction.

        Update existing recurring transaction.

        :param id: The ID of the recurring transaction. (required)
        :type id: str
        :param recurrence_update: JSON array with updated recurring transaction information. See the model for the exact specifications. (required)
        :type recurrence_update: RecurrenceUpdate
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._update_recurrence_serialize(
            id=id,
            recurrence_update=recurrence_update,
            x_trace_id=x_trace_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RecurrenceSingle",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '422': "ValidationErrorResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def update_recurrence_without_preload_content(
        self,
        id: Annotated[StrictStr, Field(description="The ID of the recurring transaction.")],
        recurrence_update: Annotated[RecurrenceUpdate, Field(description="JSON array with updated recurring transaction information. See the model for the exact specifications.")],
        x_trace_id: Annotated[Optional[StrictStr], Field(description="Unique identifier associated with this request.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Update existing recurring transaction.

        Update existing recurring transaction.

        :param id: The ID of the recurring transaction. (required)
        :type id: str
        :param recurrence_update: JSON array with updated recurring transaction information. See the model for the exact specifications. (required)
        :type recurrence_update: RecurrenceUpdate
        :param x_trace_id: Unique identifier associated with this request.
        :type x_trace_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._update_recurrence_serialize(
            id=id,
            recurrence_update=recurrence_update,
            x_trace_id=x_trace_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "RecurrenceSingle",
            '400': "BadRequestResponse",
            '401': "UnauthenticatedResponse",
            '404': "NotFoundResponse",
            '422': "ValidationErrorResponse",
            '500': "InternalExceptionResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _update_recurrence_serialize(
        self,
        id,
        recurrence_update,
        x_trace_id,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if id is not None:
            _path_params['id'] = id
        # process the query parameters
        # process the header parameters
        if x_trace_id is not None:
            _header_params['X-Trace-Id'] = x_trace_id
        # process the form parameters
        # process the body parameter
        if recurrence_update is not None:
            _body_params = recurrence_update


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/vnd.api+json', 
                'application/json'
            ]
        )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json', 
                        'application/x-www-form-urlencoded'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'firefly_iii_auth', 
            'local_bearer_auth'
        ]

        return self.api_client.param_serialize(
            method='PUT',
            resource_path='/v1/recurrences/{id}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


