# coding: utf-8

"""
    Firefly III API Client

    This is the Python client for Firefly III API

    The version of the OpenAPI document: 6.1.24
    Contact: james@firefly-iii.org
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from firefly_iii_client.models.auto_budget_period import AutoBudgetPeriod
from firefly_iii_client.models.auto_budget_type import AutoBudgetType
from typing import Optional, Set
from typing_extensions import Self

class BudgetStore(BaseModel):
    """
    BudgetStore
    """ # noqa: E501
    active: Optional[StrictBool] = None
    auto_budget_amount: Optional[StrictStr] = None
    auto_budget_currency_code: Optional[StrictStr] = Field(default=None, description="Use either currency_id or currency_code. Defaults to the user's default currency.")
    auto_budget_currency_id: Optional[StrictStr] = Field(default=None, description="Use either currency_id or currency_code. Defaults to the user's default currency.")
    auto_budget_period: Optional[AutoBudgetPeriod] = None
    auto_budget_type: Optional[AutoBudgetType] = None
    name: StrictStr
    notes: Optional[StrictStr] = None
    order: Optional[StrictInt] = None
    __properties: ClassVar[List[str]] = ["active", "auto_budget_amount", "auto_budget_currency_code", "auto_budget_currency_id", "auto_budget_period", "auto_budget_type", "name", "notes", "order"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BudgetStore from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "order",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if auto_budget_amount (nullable) is None
        # and model_fields_set contains the field
        if self.auto_budget_amount is None and "auto_budget_amount" in self.model_fields_set:
            _dict['auto_budget_amount'] = None

        # set to None if auto_budget_currency_code (nullable) is None
        # and model_fields_set contains the field
        if self.auto_budget_currency_code is None and "auto_budget_currency_code" in self.model_fields_set:
            _dict['auto_budget_currency_code'] = None

        # set to None if auto_budget_currency_id (nullable) is None
        # and model_fields_set contains the field
        if self.auto_budget_currency_id is None and "auto_budget_currency_id" in self.model_fields_set:
            _dict['auto_budget_currency_id'] = None

        # set to None if auto_budget_period (nullable) is None
        # and model_fields_set contains the field
        if self.auto_budget_period is None and "auto_budget_period" in self.model_fields_set:
            _dict['auto_budget_period'] = None

        # set to None if auto_budget_type (nullable) is None
        # and model_fields_set contains the field
        if self.auto_budget_type is None and "auto_budget_type" in self.model_fields_set:
            _dict['auto_budget_type'] = None

        # set to None if notes (nullable) is None
        # and model_fields_set contains the field
        if self.notes is None and "notes" in self.model_fields_set:
            _dict['notes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BudgetStore from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "active": obj.get("active"),
            "auto_budget_amount": obj.get("auto_budget_amount"),
            "auto_budget_currency_code": obj.get("auto_budget_currency_code"),
            "auto_budget_currency_id": obj.get("auto_budget_currency_id"),
            "auto_budget_period": obj.get("auto_budget_period"),
            "auto_budget_type": obj.get("auto_budget_type"),
            "name": obj.get("name"),
            "notes": obj.get("notes"),
            "order": obj.get("order")
        })
        return _obj


